
# LFAQ v1.0.1  
## Contents
- [Overview](#overview)  
- [Repository Contents](#repository-contents)  
- [System Requirements](#system-requirements)  
- [Documentation](#documentation)
- [The Latest Version](#the-latest-version)
- [Licensing](#licensing)
- [Contacts](#contacts)
- [Acknowledgments](#acknowledgments)
# Overview

LFAQ is a novel algorithm for label-free absolute protein quantification, which can correct the biased MS intensities using the predicted peptide quantitative factors for all identified peptides.
# Repository Contents
[ExecutableFiles](./ExecutableFiles): The executable files of LFAQ  
[Sourcecode](./Sourcecode):The source codes of LFAQ   
[TestData](./TestData): Real datasets to demo LFAQ  

# System Requirements
## Hardware Requirements
 + 1 CPU processor at 2.4 GHz or higher  
 + 2G RAM or higher  
 + 100G of free hard disk space or higher
## Software Requirements
+ Verified operating system (OS) versions (32-bit or 64-bit)  
     + Windows 7 SP1  
     + Windows 10
     + Windows Server 2008 R2
     + Windows Server 2012 R2
+ .NET Framework 4.5 or above from Microsoft, which can be downloaded from [Micosoft](https://www.microsoft.com/en-us/download/details.aspx?id=30653).
+ Microsoft Visual C++ Redistributable for Visual Studio 2013: download from [here](https://www.microsoft.com/en-us/download/details.aspx?id=40784).
+ R version 3.3.3 and above (for Windows) from R project
	+ Download and install R from [R-project](https://www.r-project.org/) 
	+ Set the path of RScript.exe as system environment variable
	+ Install R package "ggplot2"  
	```  
	   install.packages("ggplot2")
    ```
##  Installation

  Download the project files and Uncompress the zip package into a specified file folder. Double-click “LFAQ.exe” to run LFAQ. For detailed information, please see the file called "User Guide for LFAQ.pdf".

# Documentation

  This version of LFAQ is a full release, including source code and user guide documentation-"User Guide for LFAQ.pdf". As more releases occur, better documentation will be included.


# The Latest Version
 
  Details of the latest version can be found on the LFAQ project page under [https://lfaq.github.io/LFAQ/](https://lfaq.github.io/LFAQ/).
  
#  Licensing

  Please see the file called "LICENSE.md".

#  Contacts

  For any questions involving LFAQ, please contact us.  
<a href="mailto:1987ccpacer@163.com">Cheng Chang</a> or <a href="mailto:gao\_zhi\_qiang@126.com">ZhiQiang Gao</a>  

 
#  Acknowledgments

Dr. Cheng Chang - algorithm design and validation  
ZhiQiang Gao    - software development and optimization 

