/*
#  Copyright(C) 2015-2018 all rights reserved

#  This program is a free software; you can redistribute it and / or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.gnu.org/Licenses/
*/

#pragma once
class Constants
{
public:
	Constants(void);
	~Constants(void);
	double  m_dPi;
	//mass values
	double m_dMASS_INITIAL;
	double m_dMASS_A;
	double m_dMASS_C;
	double m_dMASS_D;
	double m_dMASS_E;
	double m_dMASS_F;
	double m_dMASS_G;
	double m_dMASS_H;
	double m_dMASS_I;
	double m_dMASS_K;
	double m_dMASS_L;
	double m_dMASS_M;
	double m_dMASS_N;
	double m_dMASS_P;
	double m_dMASS_Q;
	double m_dMASS_R;
	double m_dMASS_S;
	double m_dMASS_T;
	double m_dMASS_V;
	double m_dMASS_W;
	double m_dMASS_Y;

	//pKa values for amino acids
	double m_dPKa_N_TERM;
	double m_dPKa_C_TERM;
	double m_dPKa_K;
	double m_dPKa_R;
	double m_dPKa_H;
	double m_dPKa_D;
	double m_dPKa_E;
	double m_dPKa_C;
	double m_dPKa_Y;

	//atom-based hydrophobic moment
	//http://www.genome.ad.jp/dbget-bin/www_bget?aax1:EISD860102
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_A;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_C;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_D;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_E;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_F;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_G;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_H;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_I;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_K;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_L;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_M;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_N;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_P;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_Q;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_R;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_S;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_T;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_V;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_W;
	double m_dATOM_BASED_HYDROPHOBIC_MOMENT_Y;

	//Total propensity to be buried
	//http://www.genome.ad.jp/dbget-bin/www_bget?aax1:WERD780101
	double m_dTOTAL_PROP_TO_BE_BURIED_A;
	double m_dTOTAL_PROP_TO_BE_BURIED_C;
	double m_dTOTAL_PROP_TO_BE_BURIED_D;
	double m_dTOTAL_PROP_TO_BE_BURIED_E;
	double m_dTOTAL_PROP_TO_BE_BURIED_F;
	double m_dTOTAL_PROP_TO_BE_BURIED_G;
	double m_dTOTAL_PROP_TO_BE_BURIED_H;
	double m_dTOTAL_PROP_TO_BE_BURIED_I;
	double m_dTOTAL_PROP_TO_BE_BURIED_K;
	double m_dTOTAL_PROP_TO_BE_BURIED_L;
	double m_dTOTAL_PROP_TO_BE_BURIED_M;
	double m_dTOTAL_PROP_TO_BE_BURIED_N;
	double m_dTOTAL_PROP_TO_BE_BURIED_P;
	double m_dTOTAL_PROP_TO_BE_BURIED_Q;
	double m_dTOTAL_PROP_TO_BE_BURIED_R;
	double m_dTOTAL_PROP_TO_BE_BURIED_S;
	double m_dTOTAL_PROP_TO_BE_BURIED_T;
	double m_dTOTAL_PROP_TO_BE_BURIED_V;
	double m_dTOTAL_PROP_TO_BE_BURIED_W;
	double m_dTOTAL_PROP_TO_BE_BURIED_Y;

	//Hydropathy
	//AAIndex = YTJ820101
	//Hydropathy index (Kyte-Doolittle, 1982)
	//Kyte, J. and Doolittle, R.F.
	//A simple method for displaying the hydropathic character of a protein, J. Mol. Biol. 157, 105-132 (1982)
	double m_dHYDROPATHY_A;
	double m_dHYDROPATHY_C;
	double m_dHYDROPATHY_D;
	double m_dHYDROPATHY_E;
	double m_dHYDROPATHY_F;
	double m_dHYDROPATHY_G;
	double m_dHYDROPATHY_H;
	double m_dHYDROPATHY_I;
	double m_dHYDROPATHY_K;
	double m_dHYDROPATHY_L;
	double m_dHYDROPATHY_M;
	double m_dHYDROPATHY_N;
	double m_dHYDROPATHY_P;
	double m_dHYDROPATHY_Q;
	double m_dHYDROPATHY_R;
	double m_dHYDROPATHY_S;
	double m_dHYDROPATHY_T;
	double m_dHYDROPATHY_V;
	double m_dHYDROPATHY_W;
	double m_dHYDROPATHY_Y;

	//Normalized frequency of beta sheet (Chou-Fasman, 1978b)
	//AAIndex = CHOP780202
	//http://www.genome.jp/dbget-bin/www_bget?aaindex+CHOP780202
	double m_dNORM_FREQ_BETA_SHEET_A;
	double m_dNORM_FREQ_BETA_SHEET_C;
	double m_dNORM_FREQ_BETA_SHEET_D;
	double m_dNORM_FREQ_BETA_SHEET_E;
	double m_dNORM_FREQ_BETA_SHEET_F;
	double m_dNORM_FREQ_BETA_SHEET_G;
	double m_dNORM_FREQ_BETA_SHEET_H;
	double m_dNORM_FREQ_BETA_SHEET_I;
	double m_dNORM_FREQ_BETA_SHEET_K;
	double m_dNORM_FREQ_BETA_SHEET_L;
	double m_dNORM_FREQ_BETA_SHEET_M;
	double m_dNORM_FREQ_BETA_SHEET_N;
	double m_dNORM_FREQ_BETA_SHEET_P;
	double m_dNORM_FREQ_BETA_SHEET_Q;
	double m_dNORM_FREQ_BETA_SHEET_R;
	double m_dNORM_FREQ_BETA_SHEET_S;
	double m_dNORM_FREQ_BETA_SHEET_T;
	double m_dNORM_FREQ_BETA_SHEET_V;
	double m_dNORM_FREQ_BETA_SHEET_W;
	double m_dNORM_FREQ_BETA_SHEET_Y;

	//Normalized frequency of beta turn (Chou-Fasman, 1978b)
	//AAIndex = CHOP780203
	//http://www.genome.jp/dbget-bin/www_bget?aaindex+CHOP780203
	double m_dNORM_FREQ_BETA_TURN_A;
	double m_dNORM_FREQ_BETA_TURN_C;
	double m_dNORM_FREQ_BETA_TURN_D;
	double m_dNORM_FREQ_BETA_TURN_E;
	double m_dNORM_FREQ_BETA_TURN_F;
	double m_dNORM_FREQ_BETA_TURN_G;
	double m_dNORM_FREQ_BETA_TURN_H;
	double m_dNORM_FREQ_BETA_TURN_I;
	double m_dNORM_FREQ_BETA_TURN_K;
	double m_dNORM_FREQ_BETA_TURN_L;
	double m_dNORM_FREQ_BETA_TURN_M;
	double m_dNORM_FREQ_BETA_TURN_N;
	double m_dNORM_FREQ_BETA_TURN_P;
	double m_dNORM_FREQ_BETA_TURN_Q;
	double m_dNORM_FREQ_BETA_TURN_R;
	double m_dNORM_FREQ_BETA_TURN_S;
	double m_dNORM_FREQ_BETA_TURN_T;
	double m_dNORM_FREQ_BETA_TURN_V;
	double m_dNORM_FREQ_BETA_TURN_W;
	double m_dNORM_FREQ_BETA_TURN_Y;


	//Normalized frequency of alpha-helix (Chou-Fasman, 1978b)
	//AAIndex = CHOP780201
	//http://www.genome.jp/dbget-bin/www_bget?aaindex+CHOP780201
	double m_dNORM_FREQ_ALPHA_HELIX_A;
	double m_dNORM_FREQ_ALPHA_HELIX_C;
	double m_dNORM_FREQ_ALPHA_HELIX_D;
	double m_dNORM_FREQ_ALPHA_HELIX_E;
	double m_dNORM_FREQ_ALPHA_HELIX_F;
	double m_dNORM_FREQ_ALPHA_HELIX_G;
	double m_dNORM_FREQ_ALPHA_HELIX_H;
	double m_dNORM_FREQ_ALPHA_HELIX_I;
	double m_dNORM_FREQ_ALPHA_HELIX_K;
	double m_dNORM_FREQ_ALPHA_HELIX_L;
	double m_dNORM_FREQ_ALPHA_HELIX_M;
	double m_dNORM_FREQ_ALPHA_HELIX_N;
	double m_dNORM_FREQ_ALPHA_HELIX_P;
	double m_dNORM_FREQ_ALPHA_HELIX_Q;
	double m_dNORM_FREQ_ALPHA_HELIX_R;
	double m_dNORM_FREQ_ALPHA_HELIX_S;
	double m_dNORM_FREQ_ALPHA_HELIX_T;
	double m_dNORM_FREQ_ALPHA_HELIX_V;
	double m_dNORM_FREQ_ALPHA_HELIX_W;
	double m_dNORM_FREQ_ALPHA_HELIX_Y;

	//Principal property value z3 (Wold et al., 1987)
	//AAIndex = WOLS870103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:WOLS870103
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_A;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_C;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_D;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_E;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_F;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_G;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_H;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_I;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_K;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_L;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_M;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_N;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_P;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_Q;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_R;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_S;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_T;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_V;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_W;
	double m_dPRINCIPAL_PROPERTY_VALUE_Z3_Y;

	//Helix termination parameter at posision j+1 (Finkelstein et al., 1991)
	//AAINDEX = FINA910104 
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FINA910104
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_A;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_C;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_D;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_E;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_F;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_G;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_H;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_I;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_K;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_L;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_M;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_N;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_P;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_Q;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_S;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_R;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_T;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_V;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_W;
	double m_dHELIX_TERMINATION_PARA_AT_POSI_JPLUS1_Y;

	//Buriability
	//AAINDEX = ZHOH040103 
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:ZHOH040103
	double BURIABILITY_A;
	double BURIABILITY_C;
	double BURIABILITY_D;
	double BURIABILITY_E;
	double BURIABILITY_F;
	double BURIABILITY_G;
	double BURIABILITY_H;
	double BURIABILITY_I;
	double BURIABILITY_K;
	double BURIABILITY_L;
	double BURIABILITY_M;
	double BURIABILITY_N;
	double BURIABILITY_P;
	double BURIABILITY_Q;
	double BURIABILITY_R;
	double BURIABILITY_S;
	double BURIABILITY_T;
	double BURIABILITY_V;
	double BURIABILITY_W;
	double BURIABILITY_Y;

	//Number of hydrogen bond donors (Fauchere et al., 1988)
	//AAINDEX = FAUJ880109
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FAUJ880109
	double NUMBER_OF_HYDROGEN_BOND_DONORS_A;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_C;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_D;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_E;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_F;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_G;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_H;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_I;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_K;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_L;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_M;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_N;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_P;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_Q;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_R;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_S;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_T;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_V;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_W;
	double NUMBER_OF_HYDROGEN_BOND_DONORS_Y;

	//Relative preference value at N5 (Richardson-Richardson, 1988)
	//AAINDEX = RICJ880108
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:RICJ880108
	double RELATIVE_PREFERENCE_VALUE_AT_N5_A;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_C;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_D;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_E;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_F;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_G;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_H;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_I;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_K;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_L;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_M;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_N;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_P;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_Q;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_R;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_S;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_T;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_V;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_W;
	double RELATIVE_PREFERENCE_VALUE_AT_N5_Y;

	//STERIMOL length of the side chain (Fauchere et al., 1988)
	//AAINDEX = FAUJ880104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FAUJ880104
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_A;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_C;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_D;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_E;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_F;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_G;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_H;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_I;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_K;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_L;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_M;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_N;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_P;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_Q;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_R;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_S;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_T;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_V;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_W;
	double STERIMOL_LENGTH_OF_THE_SIDE_CHAIN_Y;

	//Weights for alpha-helix at the window position of 6 (Qian-Sejnowski, 1988)
	//AAINDEX = QIAN880113
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880113
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_A;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_C;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_D;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_E;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_F;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_G;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_H;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_I;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_K;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_L;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_M;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_N;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_P;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_Q;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_R;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_S;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_T;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_V;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_W;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_6_Y;

	// Relative preference value at C2 (Richardson-Richardson, 1988)
	//AAINDEX = RICJ880113
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:RICJ880113
	double RELATIVE_PREFERENCE_VALUE_AT_C2_A;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_C;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_D;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_E;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_F;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_G;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_H;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_I;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_K;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_L;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_M;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_N;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_P;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_Q;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_R;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_S;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_T;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_V;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_W;
	double RELATIVE_PREFERENCE_VALUE_AT_C2_Y;

	//Weights for alpha-helix at the window position of -6 (Qian-Sejnowski, 1988)
	//QIAN880101 
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880101
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_A;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_C;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_D;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_E;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_F;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_G;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_H;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_I;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_K;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_L;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_M;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_N;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_P;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_Q;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_R;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_S;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_T;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_V;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_W;
	double WEIGHTS_FOR_ALPHA_HELIX_AT_THE_WINDOW_POSITION_OF_MINUS6_Y;

	//Hydrophobicity index, 3.0 pH (Cowan-Whittaker, 1990)
	//COWR900101
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:COWR900101
	double HYDROPHOBICITY_INDEX_3DOT0_PH_A;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_C;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_D;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_E;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_F;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_G;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_H;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_I;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_K;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_L;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_M;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_N;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_P;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_Q;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_R;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_S;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_T;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_V;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_W;
	double HYDROPHOBICITY_INDEX_3DOT0_PH_Y;

	//Information measure for C-terminal helix (Robson-Suzuki, 1976)
	//AAINDEX = ROBB760104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:ROBB760104
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_A;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_C;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_D;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_E;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_F;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_G;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_H;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_I;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_K;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_L;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_M;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_N;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_P;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_Q;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_R;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_S;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_T;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_V;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_W;
	double INFO_MEASURE_FOR_C_TERMINAL_HELIX_Y;

	//Weights for coil at the window position of -6 (Qian-Sejnowski, 1988)
	//QIAN880127
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880127
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_A;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_C;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_D;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_E;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_F;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_G;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_H;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_I;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_K;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_L;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_M;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_N;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_P;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_Q;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_R;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_S;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_T;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_V;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_W;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS6_Y;

	//Hydrophobicity coefficient in RP-HPLC, C4 with 0.1%TFA/MeCN/H2O (Wilce et al. 1995)
	//AAINDEX = WILM950103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:WILM950103
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_A;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_C;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_D;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_E;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_F;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_G;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_H;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_I;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_K;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_L;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_M;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_N;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_P;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_Q;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_R;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_S;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_T;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_V;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_W;
	double HYDROPHOBICITY_COEFFICIENT_IN_RP_HPLC_Y;

	//Fraction of site occupied by water (Krigbaum-Komoriya, 1979)
	//AAINDEX = KRIW790102 
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:KRIW790102
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_A;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_C;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_D;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_E;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_F;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_G;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_H;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_I;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_K;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_L;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_M;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_N;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_P;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_Q;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_R;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_S;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_T;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_V;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_W;
	double FRACTION_OF_SITE_OCCUPIED_BY_WATER_Y;

	//Normalized positional residue frequency at helix termini C2 (Aurora-Rose, 1998)
	//AAINDEX = AURR980114
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:AURR980114
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_A;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_C;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_D;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_E;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_F;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_G;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_H;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_I;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_K;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_L;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_M;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_N;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_P;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_Q;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_R;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_S;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_T;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_V;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_W;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_C2_Y;

	//Normalized positional residue frequency at helix termini N'(Aurora-Rose, 1998)
	//AAINDEX = AURR980104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:AURR980104
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_A;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_C;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_D;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_E;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_F;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_G;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_H;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_I;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_K;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_L;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_M;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_N;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_P;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_Q;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_R;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_S;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_T;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_V;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_W;
	double NORMALIZED_POSITIONAL_RESIDUE_FREQUENCY_AT_HELIX_TERMINI_N_Y;

	//Optical rotation (Fasman, 1976)
	//AAINDEX = FASG760103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FASG760103
	double OPTICAL_ROTATION_A;
	double OPTICAL_ROTATION_C;
	double OPTICAL_ROTATION_D;
	double OPTICAL_ROTATION_E;
	double OPTICAL_ROTATION_F;
	double OPTICAL_ROTATION_G;
	double OPTICAL_ROTATION_H;
	double OPTICAL_ROTATION_I;
	double OPTICAL_ROTATION_K;
	double OPTICAL_ROTATION_L;
	double OPTICAL_ROTATION_M;
	double OPTICAL_ROTATION_N;
	double OPTICAL_ROTATION_P;
	double OPTICAL_ROTATION_Q;
	double OPTICAL_ROTATION_R;
	double OPTICAL_ROTATION_S;
	double OPTICAL_ROTATION_T;
	double OPTICAL_ROTATION_V;
	double OPTICAL_ROTATION_W;
	double OPTICAL_ROTATION_Y;

	//Optimized transfer energy parameter (Oobatake et al., 1985)
	//OOBM850103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:OOBM850103
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_A;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_C;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_D;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_E;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_F;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_G;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_H;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_I;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_K;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_L;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_M;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_N;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_P;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_Q;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_R;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_S;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_T;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_V;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_W;
	double OPTIMIZED_TRANSFER_ENERGY_PARAMETER_Y;

	//Weights for coil at the window position of 5 (Qian-Sejnowski, 1988)
	//AAINDEX = QIAN880138
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880138
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_A;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_C;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_D;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_E;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_F;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_G;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_H;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_I;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_K;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_L;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_M;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_N;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_P;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_Q;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_R;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_S;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_T;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_V;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_W;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_5_Y;

	//Relative preference value at C1 (Richardson-Richardson, 1988)
	//AAINDEX = RICJ880114
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:RICJ880114
	double RELATIVE_PREFERENCE_VALUE_AT_C1_A;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_C;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_D;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_E;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_F;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_G;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_H;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_I;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_K;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_L;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_M;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_N;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_P;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_Q;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_R;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_S;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_T;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_V;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_W;
	double RELATIVE_PREFERENCE_VALUE_AT_C1_Y;

	//Correlation coefficient in regression analysis (Prabhakaran-Ponnuswamy, 1982)
	//AAINDEX = PRAM820103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:PRAM820103
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_A;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_C;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_D;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_E;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_F;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_G;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_H;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_I;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_K;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_L;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_M;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_N;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_P;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_Q;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_R;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_S;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_T;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_V;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_W;
	double CORRELATION_COEFFICIENT_IN_REGRESSION_ANALYSIS_Y;

	//Weights for coil at the window position of 3 (Qian-Sejnowski, 1988)
	//AAINDEX = QIAN880136
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880136
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_A;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_C;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_D;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_E;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_F;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_G;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_H;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_I;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_K;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_L;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_M;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_N;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_P;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_Q;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_R;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_S;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_T;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_V;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_W;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_3_Y;

	//Principal component III (Sneath, 1966)
	//AAINDEX = SNEP660103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:SNEP660103
	double PRINCIPAL_COMPONENT_III_A;
	double PRINCIPAL_COMPONENT_III_C;
	double PRINCIPAL_COMPONENT_III_D;
	double PRINCIPAL_COMPONENT_III_E;
	double PRINCIPAL_COMPONENT_III_F;
	double PRINCIPAL_COMPONENT_III_G;
	double PRINCIPAL_COMPONENT_III_H;
	double PRINCIPAL_COMPONENT_III_I;
	double PRINCIPAL_COMPONENT_III_K;
	double PRINCIPAL_COMPONENT_III_L;
	double PRINCIPAL_COMPONENT_III_M;
	double PRINCIPAL_COMPONENT_III_N;
	double PRINCIPAL_COMPONENT_III_P;
	double PRINCIPAL_COMPONENT_III_Q;
	double PRINCIPAL_COMPONENT_III_R;
	double PRINCIPAL_COMPONENT_III_S;
	double PRINCIPAL_COMPONENT_III_T;
	double PRINCIPAL_COMPONENT_III_V;
	double PRINCIPAL_COMPONENT_III_W;
	double PRINCIPAL_COMPONENT_III_Y;

	//pK-N (Fasman, 1976)
	//AAINDEX = FASG760104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FASG760104
	double PK_N_A;
	double PK_N_C;
	double PK_N_D;
	double PK_N_E;
	double PK_N_F;
	double PK_N_G;
	double PK_N_H;
	double PK_N_I;
	double PK_N_K;
	double PK_N_L;
	double PK_N_M;
	double PK_N_N;
	double PK_N_P;
	double PK_N_Q;
	double PK_N_R;
	double PK_N_S;
	double PK_N_T;
	double PK_N_V;
	double PK_N_W;
	double PK_N_Y;

	//Free energy change of alpha(Ri) to alpha(Rh) (Wertz-Scheraga, 1978)
	//AAINDEX = WERD780103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:WERD780103
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_A;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_C;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_D;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_E;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_F;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_G;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_H;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_I;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_K;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_L;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_M;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_N;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_P;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_Q;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_R;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_S;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_T;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_V;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_W;
	double FREE_ENERGY_CHANGE_OF_ALPHARI_TO_ALPHARH_Y;

	//Information measure for N-terminal helix (Robson-Suzuki, 1976)
	//AAINDEX = ROBB760102
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:ROBB760102
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_A;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_C;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_D;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_E;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_F;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_G;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_H;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_I;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_K;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_L;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_M;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_N;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_P;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_Q;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_R;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_S;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_T;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_V;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_W;
	double INFORMATION_MEASURE_FOR_N_TERMINAL_HELIX_Y;

	//Unfolding Gibbs energy in water, pH9.0 (Yutani et al., 1987)
	//AAINDEX = YUTK870102
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:YUTK870102
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_A;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_C;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_D;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_E;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_F;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_G;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_H;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_I;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_K;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_L;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_M;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_N;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_P;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_Q;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_R;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_S;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_T;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_V;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_W;
	double UNFOLDING_GIBBS_ENERGY_IN_WATER_PH9_Y;

	//Average relative fractional occurrence in AL(i) (Rackovsky-Scheraga, 1982)
	//AAINDEX = RACS820103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:RACS820103
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_A;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_C;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_D;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_E;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_F;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_G;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_H;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_I;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_K;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_L;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_M;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_N;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_P;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_Q;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_R;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_S;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_T;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_V;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_W;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALI_Y;

	//Weights for coil at the window position of 6 (Qian-Sejnowski, 1988)
	//QIAN880139
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880139
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_A;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_C;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_D;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_E;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_F;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_G;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_H;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_I;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_K;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_L;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_M;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_N;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_P;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_Q;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_R;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_S;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_T;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_V;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_W;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_6_Y;

	//Optimized propensity to form reverse turn (Oobatake et al., 1985)
	//AAINEX = OOBM850102
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:OOBM850102
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_A;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_C;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_D;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_E;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_F;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_G;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_H;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_I;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_K;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_L;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_M;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_N;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_P;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_Q;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_R;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_S;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_T;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_V;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_W;
	double OPTIMIZED_PROPENSITY_TO_FORM_REVERSE_TURN_Y;

	//Information measure for C-terminal turn (Robson-Suzuki, 1976) 
	//AAINDEX = ROBB760111
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:ROBB760111
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_A;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_C;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_D;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_E;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_F;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_G;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_H;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_I;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_K;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_L;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_M;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_N;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_P;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_Q;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_R;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_S;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_T;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_V;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_W;
	double INFORMATION_MEASURE_FOR_C_TERMINAL_TURN_Y;

	//Composition of amino acids in nuclear proteins (percent) (Cedano et al., 1997)
	//AAINDEX = CEDJ970105
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:CEDJ970105
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_A;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_C;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_D;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_E;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_F;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_G;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_H;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_I;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_K;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_L;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_M;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_N;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_P;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_Q;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_R;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_S;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_T;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_V;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_W;
	double COMPOSITION_OF_AA_IN_NUCLEAR_PROTEINS_PERCENT_Y;

	//Optimized average non-bonded energy per atom (Oobatake et al., 1985)
	//AAINDEX = OOBM850104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:OOBM850104
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_A;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_C;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_D;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_E;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_F;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_G;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_H;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_I;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_K;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_L;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_M;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_N;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_P;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_Q;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_R;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_S;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_T;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_V;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_W;
	double OPTIMIZED_AVERAGE_NON_BONDED_ENERGY_PER_ATOM_Y;

	//AA composition of mt-proteins from animal (Nakashima et al., 1990)
	//AAINDEX = NAKH900105
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:NAKH900105
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_A;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_C;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_D;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_E;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_F;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_G;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_H;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_I;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_K;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_L;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_M;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_N;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_P;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_Q;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_R;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_S;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_T;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_V;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_W;
	double AA_COMPOSITION_OF_MT_PROTEINS_FROM_ANIMAL_Y;

	//Average relative fractional occurrence in AL(i-1) (Rackovsky-Scheraga, 1982)
	//AAINDEX = RACS820109
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:RACS820109
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_A;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_C;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_D;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_E;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_F;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_G;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_H;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_I;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_K;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_L;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_M;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_N;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_P;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_Q;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_R;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_S;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_T;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_V;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_W;
	double AVERAGE_RELATIVE_FRACTIONAL_OCCURENCE_IN_ALiMinus1_Y;

	//Free energy in beta-strand region (Munoz-Serrano, 1994)
	//AAINDEX = MUNV940105
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:MUNV940105
	double FREE_ENERGY_IN_BETA_STRAND_REGION_A;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_C;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_D;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_E;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_F;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_G;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_H;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_I;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_K;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_L;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_M;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_N;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_P;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_Q;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_R;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_S;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_T;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_V;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_W;
	double FREE_ENERGY_IN_BETA_STRAND_REGION_Y;

	//Slopes dekapeptide, FDPB VFF neutral (Avbelj, 2000)
	//AAINDEX = AVBF000108 
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:AVBF000108
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_A;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_C;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_D;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_E;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_F;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_G;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_H;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_I;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_K;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_L;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_M;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_N;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_P;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_Q;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_R;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_S;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_T;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_V;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_W;
	double SLOPES_DEKAPEPTIDE_FDPB_VFF_NEUTRAL_Y;

	//Weights for coil at the window position of -4 (Qian-Sejnowski, 1988)
	//AAINDEX = QIAN880129
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:QIAN880129
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_A;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_C;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_D;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_E;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_F;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_G;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_H;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_I;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_K;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_L;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_M;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_N;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_P;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_Q;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_R;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_S;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_T;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_V;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_W;
	double WEIGHTS_FOR_COIL_AT_THE_WINDOW_POSITION_OF_MINUS4_Y;

	//A parameter defined from the residuals obtained from the best correlation of the Chou-Fasman parameter of beta-sheet (Charton-Charton, 1983)
	//AAINDEX = CHAM830102
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:CHAM830102
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_A;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_C;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_D;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_E;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_F;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_G;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_H;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_I;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_K;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_L;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_M;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_N;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_P;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_Q;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_R;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_S;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_T;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_V;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_W;
	double A_PARA_DEF_FROM_THE_RESIDUALS_OBTAINED_FROM_THE_BEST_CORRELATION_OF_CF_PARA_OF_BETA_SHEET_Y;

	/*---------------below are from 12/16/2013-----------------------------------*/
	//Normalized flexibility parameters (B-values), average (Vihinen et al., 1994)
	//AAINDEX=VINM940101
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:VINM940101
	double Normalized_Flexibility_Parameters_B_Values_A;
	double Normalized_Flexibility_Parameters_B_Values_C;
	double Normalized_Flexibility_Parameters_B_Values_D;
	double Normalized_Flexibility_Parameters_B_Values_E;
	double Normalized_Flexibility_Parameters_B_Values_F;
	double Normalized_Flexibility_Parameters_B_Values_G;
	double Normalized_Flexibility_Parameters_B_Values_H;
	double Normalized_Flexibility_Parameters_B_Values_I;
	double Normalized_Flexibility_Parameters_B_Values_K;
	double Normalized_Flexibility_Parameters_B_Values_L;
	double Normalized_Flexibility_Parameters_B_Values_M;
	double Normalized_Flexibility_Parameters_B_Values_N;
	double Normalized_Flexibility_Parameters_B_Values_P;
	double Normalized_Flexibility_Parameters_B_Values_Q;
	double Normalized_Flexibility_Parameters_B_Values_R;
	double Normalized_Flexibility_Parameters_B_Values_S;
	double Normalized_Flexibility_Parameters_B_Values_T;
	double Normalized_Flexibility_Parameters_B_Values_V;
	double Normalized_Flexibility_Parameters_B_Values_W;
	double Normalized_Flexibility_Parameters_B_Values_Y;

	//Normalized van der Waals volume (Fauchere et al., 1988)
	//AAINDEX = FAUJ880103
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:FAUJ880103
	double Normalized_Van_Der_Waals_Volume_A;
	double Normalized_Van_Der_Waals_Volume_C;
	double Normalized_Van_Der_Waals_Volume_D;
	double Normalized_Van_Der_Waals_Volume_E;
	double Normalized_Van_Der_Waals_Volume_F;
	double Normalized_Van_Der_Waals_Volume_G;
	double Normalized_Van_Der_Waals_Volume_H;
	double Normalized_Van_Der_Waals_Volume_I;
	double Normalized_Van_Der_Waals_Volume_K;
	double Normalized_Van_Der_Waals_Volume_L;
	double Normalized_Van_Der_Waals_Volume_M;
	double Normalized_Van_Der_Waals_Volume_N;
	double Normalized_Van_Der_Waals_Volume_P;
	double Normalized_Van_Der_Waals_Volume_Q;
	double Normalized_Van_Der_Waals_Volume_R;
	double Normalized_Van_Der_Waals_Volume_S;
	double Normalized_Van_Der_Waals_Volume_T;
	double Normalized_Van_Der_Waals_Volume_V;
	double Normalized_Van_Der_Waals_Volume_W;
	double Normalized_Van_Der_Waals_Volume_Y;

	//RF value in high salt chromatography (Weber-Lacey, 1978)
	//AAINDEX=WEBA780101
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:WEBA780101
	double RF_Value_In_High_Salt_Chromatography_A;
	double RF_Value_In_High_Salt_Chromatography_C;
	double RF_Value_In_High_Salt_Chromatography_D;
	double RF_Value_In_High_Salt_Chromatography_E;
	double RF_Value_In_High_Salt_Chromatography_F;
	double RF_Value_In_High_Salt_Chromatography_G;
	double RF_Value_In_High_Salt_Chromatography_H;
	double RF_Value_In_High_Salt_Chromatography_I;
	double RF_Value_In_High_Salt_Chromatography_K;
	double RF_Value_In_High_Salt_Chromatography_L;
	double RF_Value_In_High_Salt_Chromatography_M;
	double RF_Value_In_High_Salt_Chromatography_N;
	double RF_Value_In_High_Salt_Chromatography_P;
	double RF_Value_In_High_Salt_Chromatography_Q;
	double RF_Value_In_High_Salt_Chromatography_R;
	double RF_Value_In_High_Salt_Chromatography_S;
	double RF_Value_In_High_Salt_Chromatography_T;
	double RF_Value_In_High_Salt_Chromatography_V;
	double RF_Value_In_High_Salt_Chromatography_W;
	double RF_Value_In_High_Salt_Chromatography_Y;

	//Isoelectric point (Zimmerman et al., 1968)
	//AAINDEX = ZIMJ680104
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:ZIMJ680104
	double Isoelectric_Point_A;
	double Isoelectric_Point_C;
	double Isoelectric_Point_D;
	double Isoelectric_Point_E;
	double Isoelectric_Point_F;
	double Isoelectric_Point_G;
	double Isoelectric_Point_H;
	double Isoelectric_Point_I;
	double Isoelectric_Point_K;
	double Isoelectric_Point_L;
	double Isoelectric_Point_M;
	double Isoelectric_Point_N;
	double Isoelectric_Point_P;
	double Isoelectric_Point_Q;
	double Isoelectric_Point_R;
	double Isoelectric_Point_S;
	double Isoelectric_Point_T;
	double Isoelectric_Point_V;
	double Isoelectric_Point_W;
	double Isoelectric_Point_Y;

	//Average surrounding hydrophobicity (Manavalan-Ponnuswamy, 1978)
	//AAINDEX = MANP780101
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:MANP780101
	double Average_Surrounding_Hydrophobicity_A;
	double Average_Surrounding_Hydrophobicity_C;
	double Average_Surrounding_Hydrophobicity_D;
	double Average_Surrounding_Hydrophobicity_E;
	double Average_Surrounding_Hydrophobicity_F;
	double Average_Surrounding_Hydrophobicity_G;
	double Average_Surrounding_Hydrophobicity_H;
	double Average_Surrounding_Hydrophobicity_I;
	double Average_Surrounding_Hydrophobicity_K;
	double Average_Surrounding_Hydrophobicity_L;
	double Average_Surrounding_Hydrophobicity_M;
	double Average_Surrounding_Hydrophobicity_N;
	double Average_Surrounding_Hydrophobicity_P;
	double Average_Surrounding_Hydrophobicity_Q;
	double Average_Surrounding_Hydrophobicity_R;
	double Average_Surrounding_Hydrophobicity_S;
	double Average_Surrounding_Hydrophobicity_T;
	double Average_Surrounding_Hydrophobicity_V;
	double Average_Surrounding_Hydrophobicity_W;
	double Average_Surrounding_Hydrophobicity_Y;

	//Retention coefficient at pH 2 (Guo et al., 1986)
	//AAINDEX = GUOD860101;
	//http://www.genome.jp/dbget-bin/www_bget?aaindex:GUOD860101
	double Retention_Coefficient_At_Ph_2_A;
	double Retention_Coefficient_At_Ph_2_C;
	double Retention_Coefficient_At_Ph_2_D;
	double Retention_Coefficient_At_Ph_2_E;
	double Retention_Coefficient_At_Ph_2_F;
	double Retention_Coefficient_At_Ph_2_G;
	double Retention_Coefficient_At_Ph_2_H;
	double Retention_Coefficient_At_Ph_2_I;
	double Retention_Coefficient_At_Ph_2_K;
	double Retention_Coefficient_At_Ph_2_L;
	double Retention_Coefficient_At_Ph_2_M;
	double Retention_Coefficient_At_Ph_2_N;
	double Retention_Coefficient_At_Ph_2_P;
	double Retention_Coefficient_At_Ph_2_Q;
	double Retention_Coefficient_At_Ph_2_R;
	double Retention_Coefficient_At_Ph_2_S;
	double Retention_Coefficient_At_Ph_2_T;
	double Retention_Coefficient_At_Ph_2_V;
	double Retention_Coefficient_At_Ph_2_W;
	double Retention_Coefficient_At_Ph_2_Y;

};

